#include <mpi.h>
#include <stdio.h>

int main(int argc, char **argv)
{
  int numtasks, rank, tag = 11111;
  int data[3];

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &numtasks);

  if (rank == 0) {
    int input[3][3] = {{33, 42, 313}, {4, 43, 4711}, {87, 42, 43}};
    for (int i = 0; i < numtasks; ++i) {
      // HERE
      MPI_Bsend(input[i], 3, MPI_INT, i, tag, MPI_COMM_WORLD);
    }
  }

  // HERE
  MPI_Recv(data, 3, MPI_INT, 0, tag, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

  int result[3];
  //MPI_Barrier(MPI_COMM_WORLD);

  // HERE
  MPI_Reduce(data, result, 3, MPI_INT, MPI_MIN, 0, MPI_COMM_WORLD);

  if (rank == 0) {
    for (int i = 0; i < 3; i++) {
      printf("%d ", result[i]);
    }
    printf("\n");
  }

  MPI_Finalize();
}
